package com.gct.aoid.algorithm;

import com.gct.aoid.entity.AoidSinglewellConfig;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Vector;

/**
 * class name: CalDigramProduction
 * 计算单张功图的产液量
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/28 下午5:14
 */
@Component
public class CalDiagramProduction {
    class CardSlopeRec {
        public double Card_Shift;
        public double Card_Slope;
        public double PumpCard_Shift;
        public double PumpCard_Slope;
    }

    static public class CalProductionResult {
        public Double rcyl1;
        public Double rcyl;
        public Double rcsl;
        public Double rcql;
        public Double bx;
        public Double llpl;
        public Double sjcc;
        public Double yxcc;
        public Double zcc;
        public Double ycc;
        public Double ccss;
        public Double lsss;
        public Double gyss;
        public Double l_StrokeRatio;
        public String remark;

       public void formatted(){
           if(Objects.nonNull(rcyl)) rcyl= Math.round(rcyl * 10) / 10d;
           if(Objects.nonNull(rcyl1)) rcyl1= Math.round(rcyl1 * 10) / 10d;
           if(Objects.nonNull(rcql)) rcql= Math.round(rcql * 10) / 10d;
           if(Objects.nonNull(rcsl)) rcsl= Math.round(rcsl * 10) / 10d;
           if(Objects.nonNull(bx)) bx= Math.round(bx * 100) / 100d;
           if(Objects.nonNull(llpl)) llpl= Math.round(llpl * 10) / 10d;
           if(Objects.nonNull(sjcc)) sjcc= Math.round(sjcc * 10) / 10d;
           if(Objects.nonNull(yxcc)) yxcc= Math.round(yxcc * 10) / 10d;
           if(Objects.nonNull(ycc)) ycc= Math.round(ycc * 10) / 10d;
           if(Objects.nonNull(ccss)) ccss= Math.round(ccss * 100) / 100d;
           if(Objects.nonNull(lsss)) lsss= Math.round(lsss * 100) / 100d;
           if(Objects.nonNull(gyss)) gyss= Math.round(gyss * 100) / 100d;
           if(Objects.nonNull(l_StrokeRatio)) l_StrokeRatio= Math.round(l_StrokeRatio * 100) / 100d;

       }
    }

    public static void main(String[] args) {
        System.out.println("Math.round(0.2365) = " + Math.round(0.2365 * 0.1d));
    }
    public CalProductionResult calProduction(Double[][] sgt, Double[][] bgt, double cc,
                                             double cc1, String zdjg,
                                             double bj, double bs, double hsl, double smd, double ymd, double qyb,
                                             double dym, double bdxs,
                                             AoidSinglewellConfig effectStrockModel) {
    /*double Card_Load;
    double Card_Shift;*/
    /*double PumpCard_Load;
    double PumpCard_Shift;*/
        double Card_MaxShift;
        double Card_MinShift;
        double Card_MaxLoad;
        double Card_MinLoad;
        double Card_Power;
        double PumpCard_MaxShift;
        double PumpCard_MinShift;
        double PumpCard_MaxLoad;
        double PumpCard_MinLoad;
        double PumpCard_Power;

        Vector<CardSlopeRec> CardSlope_array = new Vector<>();

        int Card_Point;
        String L_cjsj;
        String L_jh;
        Vector<Vector<Double>> L_bgt;
//        Vector<Vector<Double>> L_sgt;

        double L_Cycle;
        double L_Cc;
        double L_Bj;
        double L_Llbj;
        double L_Hs;
        double L_Bx;
        double L_Rcl;
        double L_Rcyl;
        double L_Rcsl;
        double L_RclT;
        double L_RcylT;
        double L_RcslT;
        double L_Rcql;
        double L_Ccsmd;
        double L_Dmyybz;
        double L_Qyb;
        double L_Dym;
        double L_Cmd;
        double L_Bs;

        double L_DownLoadLevel = 0;
        double L_UpLoadLevel = 0;
        double L_TheoryLoadLiquid = 0;
        double Productioncoefficient = 0;

        double L_TempDownLevel;
        double L_TempUpLevel;
        int L_TempNum;

        String L_Zdjg;
        String L_ZdjgJc;
        String L_Load;
        String L_Shift;
        String L_ShiftLoad;
        int L_Count;
        double l_StrokeRatio;

        int I = 1;
        int j = 0;
        int L_LeftDownPoint;
        int L_RightDownPoint;

        double L_LeftDownLoad;
        double L_RightDownLoad;
        double L_LeftDownStroke;
        double L_LeftDownStroke1;
        double L_LeftDownStroke2;
        double L_RightDownStroke;

        int L_LeftUpPoint;
        int L_RightUpPoint;
        double L_LeftUpLoad;
        double L_RightUpLoad;
        double L_LeftUpStroke;
        double L_RightUpStroke;
        double L_UpEffectiveStroke;
        double L_DivideLoad;

        String L_Zyq;
        double L_Sjcc;
        double L_Yxcc;
        double L_Zcc;
        double L_Ycc;
        double L_Ccss;
        double L_Llpl;
        double L_Lsss;
        double L_Gyss;
        double L_PumpDepth = 0;

        double L_DivideNum;
        double L_LeftDownLeak;
        double L_DownPointDivide;

        double L_Gradient = 15;
        double L_Gradient1 = 15;
        int L_UpPointDivide = 0;
        double L_Bdxs1;
        double L_Bdxs;
       /* L_sgt = sgtFormatted;
        L_bgt = bgt;*/
        L_Cc = cc;
        L_Cycle = cc1;
        L_Zdjg = zdjg;
        L_Bj = bj;
        L_Bs = bs;
        L_Hs = hsl;
        L_Ccsmd = smd;
        L_Dmyybz = ymd;
        L_Qyb = qyb;
        L_Dym = dym;
        L_Bdxs = bdxs;
        //L_zyq = zyq;
        L_LeftDownStroke = 0;
        L_LeftDownPoint = 0;
        L_LeftDownLoad = 0;
        Card_MaxShift = 0;
        Card_MinShift = 0;
        Card_MaxLoad = 0;
        Card_MinLoad = 0;
        Card_Power = 0;
        PumpCard_MaxShift = 0;
        PumpCard_MinShift = 0;
        PumpCard_MaxLoad = 0;
        PumpCard_MinLoad = 0;
        PumpCard_Power = 0;
        Card_Point = 0;
        Card_Point = sgt.length;
        Card_Power = 0;
        PumpCard_Power = 0;
        L_LeftDownStroke1 = 15;
        L_LeftDownStroke2 = -15;
        //Card_MaxLoad=std::atof(sgtFormatted.substr(3+8*(-1),5))/100;
        for (int i = 0; i < Card_Point; i++) {
            CardSlopeRec CardSlope = new CardSlopeRec();
        /* Card_Shift = sgtFormatted[i][0];
         Card_Load = sgtFormatted[i][1];
         PumpCard_Shift = L_bgt[i][0];
         PumpCard_Load = L_bgt[i][1];*/

            int previousindex = i - 1;
            if (i == 0) {
                previousindex = Card_Point - 1;
                Card_MaxLoad = sgt[i][1];
                Card_MinLoad = sgt[i][1];
                Card_MaxShift = sgt[i][0];
                Card_MinShift = sgt[i][0];
                PumpCard_MaxLoad = bgt[i][1];
                PumpCard_MinLoad = bgt[i][1];
                PumpCard_MaxShift = bgt[i][0];
                PumpCard_MinShift = bgt[i][0];
                L_LeftDownStroke = bgt[i][0];
                L_LeftDownLoad = bgt[i][1];
                L_LeftDownPoint = i;
            }
            if (Card_MaxLoad < sgt[i][1]) Card_MaxLoad = sgt[i][1];
            else if (Card_MinLoad > sgt[i][1]) Card_MinLoad = sgt[i][1];

            if (Card_MaxShift < sgt[i][0]) Card_MaxShift = sgt[i][0];
            else if (Card_MinShift > sgt[i][0]) Card_MinShift = sgt[i][0];

            if (PumpCard_MaxLoad < bgt[i][1]) PumpCard_MaxLoad = bgt[i][1];
            else if (PumpCard_MinLoad > bgt[i][1]) PumpCard_MinLoad = bgt[i][1];
            if (PumpCard_MaxShift < bgt[i][0]) PumpCard_MaxShift = bgt[i][0];
            else if (PumpCard_MinShift > bgt[i][0]) PumpCard_MinShift = bgt[i][0];

            if (bgt[i][0] >= 0 && bgt[previousindex][1] <= 0) {
                if (L_LeftDownStroke1 > (bgt[i][0] + bgt[previousindex][0]) / 2)
                    L_LeftDownStroke1 = (bgt[i][0] + bgt[previousindex][0]) / 2;
            }

            if (bgt[i][0] <= 0 && bgt[previousindex][1] >= 0) {
                if (L_LeftDownStroke2 < (bgt[i][0] + bgt[previousindex][0]) / 2) {
                    L_LeftDownStroke2 = (bgt[i][0] + bgt[i][0]) / 2;
                    //用的I TODO:check
                    //L_LeftDownStroke2 = (bgt[i][0] + bgt[previousindex][0]) / 2;
                }
            }


            int nextindex = i + 1;
            if (i == Card_Point - 1) {
                nextindex = 0;
            }
            Card_Power = Card_Power + (sgt[nextindex][1] + sgt[i][1]) * (sgt[nextindex][0] - sgt[i][0]) / 2;
            PumpCard_Power =
                    PumpCard_Power + (bgt[nextindex][1] + bgt[i][1]) * (bgt[nextindex][0] - bgt[i][0]) / 2;
            if ((sgt[nextindex][0] - sgt[i][0]) == 0)
                CardSlope.Card_Slope = 100;
            else
                CardSlope.Card_Slope = Math.abs((sgt[nextindex][1] - sgt[i][1]) / (sgt[nextindex][0] - sgt[i][0]));
            if ((bgt[nextindex][0] - bgt[i][0]) == 0)
                CardSlope.PumpCard_Slope = 100;
            else
                CardSlope.PumpCard_Slope = Math.abs(
                        (bgt[nextindex][1] - bgt[i][1]) / (bgt[nextindex][0] - bgt[i][0]));
            CardSlope.PumpCard_Shift = bgt[i][0];


            if (CardSlope.Card_Slope >= 100)
                CardSlope.Card_Slope = 100;
            if (CardSlope.Card_Slope <= -100)
                CardSlope.Card_Slope = 100;
            if (CardSlope.PumpCard_Slope >= 100)
                CardSlope.PumpCard_Slope = 100;
            if (CardSlope.PumpCard_Slope <= -100)
                CardSlope.PumpCard_Slope = 100;


            CardSlope_array.add(CardSlope);
        }

        Card_Power = Math.abs(Card_Power) / (60 / L_Cycle);
        PumpCard_Power = Math.abs(PumpCard_Power) / (60 / L_Cycle);


        L_Bx = 0;
        L_Rcl = 0;
        L_Rcyl = 0;
        L_Rcsl = 0;
        L_Rcql = 0;
        L_RightDownPoint = 0;
        L_RightDownLoad = 0;
        L_RightDownStroke = 0;
        L_LeftUpPoint = 0;
        L_RightUpPoint = 0;
        L_LeftUpLoad = 0;
        L_RightUpLoad = 0;
        L_LeftUpStroke = 0;
        L_RightUpStroke = 0;
        L_UpEffectiveStroke = 0;
        L_Sjcc = 0;
        L_Yxcc = 0;
        L_Ccss = 0;
        L_Llpl = 0;
        L_Lsss = 0;
        L_Gyss = 0;
        L_Cmd = 0;
        L_Gradient = 35;
        L_UpPointDivide = 0;
        l_StrokeRatio = 0;
        L_DivideNum = 3.5;
        L_DivideLoad = (PumpCard_MaxLoad - PumpCard_MinLoad) / L_DivideNum;

        for (int i = 0; i < Card_Point / 2; i++) {
            int lastindex = Card_Point - i - 1;
            if (bgt[lastindex][1] < (PumpCard_MinLoad + L_DivideLoad) &&
                    CardSlope_array.get(lastindex).PumpCard_Slope < L_Gradient)//jkl
                L_RightDownLoad = bgt[lastindex][1];
            L_RightDownStroke = CardSlope_array.get(lastindex).PumpCard_Shift;
            L_RightDownPoint = lastindex;
        }


        if (L_RightDownStroke == 0)
            L_RightDownStroke = L_LeftDownStroke;

        if ((PumpCard_MaxShift - PumpCard_MinShift) != 0) {
            l_StrokeRatio = (L_RightDownStroke - L_LeftDownStroke) * 100 / (PumpCard_MaxShift - PumpCard_MinShift);
        }

        if (false)
            if (L_Bdxs <= 0) {
                L_Bdxs = 1;
            }

        //IF L_BDXS IS NULL OR L_BDXS<=0 THEN L_BDXS=1; END IF;

        boolean p_gybz = L_Zdjg.contains("供液不足");
        if ((L_Zdjg.contains("供液正常") || p_gybz) && l_StrokeRatio > 80)
            L_Gradient = effectStrockModel.getGradient_1();
        L_DivideNum = effectStrockModel.getDividenum_1();

        if (p_gybz && l_StrokeRatio <= 80)
            L_Gradient = effectStrockModel.getGradient_2();
        L_DivideNum = effectStrockModel.getDividenum_2();
        if (p_gybz && l_StrokeRatio <= 45)
            L_Gradient = effectStrockModel.getGradient_3();
        L_DivideNum = effectStrockModel.getDividenum_3();
        if (p_gybz && l_StrokeRatio <= 35)
            L_Gradient = effectStrockModel.getGradient_4();
        L_DivideNum = effectStrockModel.getDividenum_4();
        if (p_gybz && l_StrokeRatio <= 25)
            L_Gradient = effectStrockModel.getGradient_5();
        L_DivideNum = effectStrockModel.getDividenum_5();
        if (p_gybz && l_StrokeRatio <= 20)
            L_Gradient = effectStrockModel.getGradient_6();
        L_DivideNum = effectStrockModel.getDividenum_6();
        if (p_gybz && l_StrokeRatio <= 15)
            L_Gradient = effectStrockModel.getGradient_7();
        L_DivideNum = effectStrockModel.getDividenum_7();
        boolean p_qyx = L_Zdjg.contains("气影响");

        if (p_qyx && l_StrokeRatio >= 35)
            L_Gradient = effectStrockModel.getGradient_8();
        L_DivideNum = effectStrockModel.getDividenum_8();
        if (p_qyx && l_StrokeRatio < 35)
            L_Gradient = effectStrockModel.getGradient_9();
        L_DivideNum = effectStrockModel.getDividenum_9();
        if (p_qyx && l_StrokeRatio < 20)
            L_Gradient = effectStrockModel.getGradient_10();
        L_DivideNum = effectStrockModel.getDividenum_10();

        L_DivideLoad = (PumpCard_MaxLoad - PumpCard_MinLoad) / L_DivideNum;

        L_DownPointDivide = 0;
        L_LeftDownLeak = 0;
        L_LeftUpStroke = 0;
        L_LeftDownLeak = 0;

        if (L_Bj > 57)
            L_Gradient1 = 5;

        for (int i = 0; i < Card_Point / 2; i++) {
            int lastindex = Card_Point - i - 1;
            if (bgt[lastindex][1] < (PumpCard_MinLoad + L_DivideLoad) &&
                    CardSlope_array.get(lastindex).PumpCard_Slope < L_Gradient) {
                L_RightDownLoad = bgt[lastindex][1];
                L_RightDownStroke = CardSlope_array.get(lastindex).PumpCard_Shift;
                L_RightDownPoint = lastindex;
                if (L_DownPointDivide == 0 && Math.abs(CardSlope_array.get(lastindex).PumpCard_Slope) < 25 &&
                        bgt[lastindex][1] < (PumpCard_MinLoad + L_DivideLoad)) {
                    L_LeftDownLeak = CardSlope_array.get(lastindex).PumpCard_Shift;
                    L_DownPointDivide = 1;
                }
            }

            if (L_UpPointDivide == 0 && Math.abs(CardSlope_array.get(i).PumpCard_Slope) < 5 &&
                    bgt[i][1] > ((PumpCard_MaxLoad - PumpCard_MinLoad) * 0.7 + PumpCard_MinLoad)) {
                L_LeftUpLoad = bgt[i][1];
                L_LeftUpStroke = CardSlope_array.get(i).PumpCard_Shift;
                L_LeftUpPoint = i;
                L_UpPointDivide = 1;
            }

            if (L_UpPointDivide == 1 && Math.abs(CardSlope_array.get(i).PumpCard_Slope) < 5 &&
                    bgt[i][1] > ((PumpCard_MaxLoad - PumpCard_MinLoad) * 0.8 + PumpCard_MinLoad)) {
                L_RightUpLoad = bgt[i][1];
                L_RightUpStroke = CardSlope_array.get(i).PumpCard_Shift;
                L_RightUpPoint = i;
            }
        }

        if (L_RightDownStroke <= 0) {
            L_RightDownStroke = L_LeftDownStroke;
        }

        //if L_RightDownStroke is null then L_RightDownStroke=L_LeftDownStroke; end if;
        if (L_Cc <= 0) {
            L_Cc = Card_MaxShift;
        }
        //if L_Cc is null then L_Cc=card_maxshift;  end if;
        L_Ycc = L_RightDownStroke;
        L_Zcc = L_LeftDownStroke;

        if (L_Bj <= 95) {
            L_Llpl = L_Cycle * L_Cc * 24 * 60 * L_Bj * L_Bj * Math.PI / 4000000;
        }

        //if L_Bj<=95 then L_Llpl=L_Cycle*L_Cc*24*60*L_Bj*L_Bj*3.1415926/4000000; end if;--理论排量---------------------------------

        L_Sjcc = PumpCard_MaxShift - PumpCard_MinShift;//--实际冲程
        L_Ccss = L_Cc - L_Sjcc;//--冲程损失

        if (L_Ccss < 0)
            L_Ccss = 0;

        //if L_Ccss<0 then L_Ccss=0; end if;
        L_Lsss = 0;

        if (L_Zdjg.contains("泵工作正常") || L_Zdjg.contains("碰泵"))
            L_Lsss = 0;
        if (L_Zdjg.contains("游动凡尔漏失"))
            L_Lsss = (PumpCard_MaxShift - L_RightUpStroke) * 2;
        if (L_Zdjg.contains("固定凡尔漏失"))
            L_Lsss = L_Lsss + (L_LeftDownLeak - PumpCard_MinShift) * 2;
        if (L_Zdjg.contains("冲次过快"))
            L_Lsss = (PumpCard_MaxShift - L_RightUpStroke) * 2;
        if (L_Lsss < 0)
            L_Lsss = 0;
        L_Yxcc = L_RightDownStroke - L_LeftDownStroke - L_Lsss;
        if (L_Yxcc <= 0)
            L_Yxcc = 0;
        L_Gyss = L_Sjcc - L_Yxcc;
        if (L_Gyss < 0)
            L_Gyss = 0;
        if (L_Gyss == 0)
            L_Bx = 0;
        else L_Bx = L_Yxcc / L_Cc * 100;


        if (L_Bj > 0 && L_Bj <= 95) {
            double v = L_Bj * L_Bj * Math.PI / 4 * 24 * 60 * L_Cycle * L_Cc * L_Bx / 100000000;
            if (v > 0.0087 * Math.pow(2.71828, 0.0027 * L_Bs))
                L_Rcl = v * L_Bdxs;//---0.0087*power(2.71828,0.0027*nvl(L_Bs,0));
            else L_Rcl = v * L_Bdxs;
            if (L_Rcl <= 0)
                L_Rcl = 0;
            if (L_Hs <= 100) {
                L_Rcsl = L_Rcl * L_Hs / 100;
                L_Rcyl = L_Rcl - L_Rcsl;
                if (L_Ccsmd > 1 && L_Ccsmd < 1.5) {
                } else
                    L_Ccsmd = 1.05;
                if (L_Dmyybz > 0.6 && L_Dmyybz < 1.5) {
                } else
                    L_Dmyybz = 0.83;
                if (L_Bs > 0)
                    L_TheoryLoadLiquid = Math.PI / 4 * (L_Bj * L_Bj / 1000000) * L_Bs *
                            ((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 *
                            (1 + L_Cycle * Card_MaxShift / 127);
                else
                    L_TheoryLoadLiquid = Math.PI / 4 * (L_Bj * L_Bj / 1000000) * L_PumpDepth *
                            ((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 *
                            (1 + L_Cycle * Card_MaxShift / 127);
                if (L_Qyb >= 0)
                    L_Rcql = L_Qyb * L_Rcyl;
                Productioncoefficient = 1;
                if ((PumpCard_MaxLoad - PumpCard_MinLoad) / L_TheoryLoadLiquid < 0.8 && !zdjg.contains("喷抽") &&
                        L_Bs > 1750)
                    Productioncoefficient = (PumpCard_MaxLoad - PumpCard_MinLoad) / L_TheoryLoadLiquid;
                /*else
                    Productioncoefficient = 1;*/
                L_Rcsl = L_Ccsmd * L_Rcsl * Productioncoefficient;
                L_Rcyl = L_Dmyybz * L_Rcyl * Productioncoefficient;
                L_Rcl = L_Rcsl + L_Rcyl;
            } else {
                L_Llbj = Math.sqrt((PumpCard_MaxLoad - PumpCard_MinLoad) * 4 / (9.8 * L_PumpDepth * Math.PI)) *
                        1000;//--+power(0.019,2)
            }
        }

        if (L_Hs < 0 || L_Dmyybz < 0 || L_Ccsmd < 0 || L_Qyb < 0 || L_Bj <= 0 || L_Bj > 95) {
            L_ZdjgJc = "基本数据不全";
            L_Zdjg += L_ZdjgJc;
        }

        L_Dym = -10;//什么情况
        if (L_Dym >= 0 && L_Bj <= 95)//什么情况
        {
            if (L_Bs <= 0)
                L_Bs = L_PumpDepth;
            if (L_Hs < 0 || L_Hs > 100)
                L_Hs = 60;
            if (L_Dmyybz <= 0)
                L_Dmyybz = 0.84;
            if (L_Ccsmd <= 0)
                L_Ccsmd = 1.05;
            if (L_Bj <= 0)
                L_Bj = 38;
        } else {
            if (L_Bs <= 0)
                L_Bs = L_PumpDepth;
            if (L_Hs < 0 || L_Hs > 100)
                L_Hs = 60;
            if (L_Dmyybz <= 0)
                L_Dmyybz = 0.84;
            if (L_Ccsmd <= 0)
                L_Ccsmd = 1.05;
            if (L_Bj <= 0 || L_Bj > 95)
                L_Bj = 38;
            if ((((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 * 0.25 * Math.PI * Math.pow(L_Bj, 2) / 1000) == 0)
                L_Cmd = 0;
            else {
                L_Cmd = Math.abs(PumpCard_MinLoad * L_Yxcc / L_Sjcc) * 1000 /
                        (((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 * 0.25 * Math.PI * Math.pow(L_Bj, 2) /
                                1000);
                L_Dym = L_Bs - L_Cmd;
            }
        }

        if (L_Gyss < PumpCard_MaxShift || L_Ccss < PumpCard_MaxShift || L_Lsss < PumpCard_MaxShift)
            PumpCard_MaxShift = L_Cc;

        double rcyl1 = L_Rcl;
        double rcyl = L_Rcyl;
        double rcsl = L_Rcsl;
        double rcql = L_Rcql;
        double bx = L_Bx;
        double llpl = L_Llpl;
        double sjcc = L_Sjcc;
        double yxcc = L_Yxcc;
        double zcc = L_Zcc;
        double ycc = L_Ycc;
        double ccss = L_Ccss;
        double lsss = L_Lsss;
        double gyss = L_Gyss;
        double pumpdepth = L_PumpDepth;
    /* std::string str = "";
     str += std::to_string(rcyl1) + ";" + std::to_string(rcyl) + ";" + std::to_string(rcsl) + ";" +
            std::to_string(rcql) + ";" + std::to_string(bx) + ";" + std::to_string(llpl) + ";" + std::to_string(sjcc) +
            ";" + std::to_string(
             yxcc) + ";" + std::to_string(zcc) +
            ";" + std::to_string(ycc) + ";" + std::to_string(ccss) + ";" + std::to_string(lsss) + ";" + std::to_string(
             gyss) + ";" + std::to_string(l_StrokeRatio) + ";";*/

        CalProductionResult res = new CalProductionResult();
        res.rcyl1 = rcyl1;
        res.rcyl = rcyl;
        res.rcsl = rcsl;
        res.rcql = rcql;
        res.bx = bx;
        res.llpl = llpl;
        res.sjcc = sjcc;
        res.yxcc = yxcc;
        res.zcc = zcc;
        res.ycc = ycc;
        res.ccss = ccss;
        res.lsss = lsss;
        res.gyss = gyss;
        res.l_StrokeRatio = l_StrokeRatio;
        res.formatted();
        return res;
    }
}
