package com.gct.aoid.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.aoid.entity.Vo.AoidYeildVo;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author gxt
 * @since 2021-01-28
 */
@Api(value = "AoidDailyYieldController", description = "功图量液")
@RestController
@RequestMapping("/aoidDailyYield")
public class AoidDailyYieldController {

    @Autowired
    private AoidDailyYieldService aoidDailyYieldService;


    @ApiOperation(value = "根据井号和日期时间段查询量液的每日基本信息" ,notes = "根据井号和日期时间段查询量液的每日基本信息")
    @PostMapping("/getAoidDailyYieldInfo")
    public Result getAoidDailyYieldInfoByWellIdAndPorDatePeriod(@RequestBody AoidYeildVo aoidYeildVo){
        List<Map<String, Object>> list =   aoidDailyYieldService.getAoidDailyYieldInfoByWellIdAndPorDatePeriod(aoidYeildVo.getWellId(), aoidYeildVo.getStartDate());
        return list==null||list.size()==0?Result.error("未找到"):Result.ok(list);
    }

    @ApiOperation(value = "根据井号和日期时间段查询量液的每日基本信息page" ,notes = "根据井号和日期时间段查询量液的每日基本信息")
    @PostMapping("/getAoidDailyYieldInfoPage")
    public Result getAoidDailyYieldInfoByWellIdAndPorDatePeriodPage(@RequestBody AoidYeildVo aoidYeildVo){
        Page<Map<String, Object>> page =   aoidDailyYieldService.getAoidDailyYieldInfoByWellIdAndPorDatePeriodByPage(aoidYeildVo.getOrg(),aoidYeildVo.getWellId(), aoidYeildVo.getStartDate(),aoidYeildVo.getSize(),aoidYeildVo.getPage());
        return page ==null|| page.getRecords().size()==0?Result.error("未找到"):Result.ok(page);
    }
}

