package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.gct.common.util.SGTUtil;
import lombok.Data;

/**
 * class name: DiagramCardBaseParam
 * 功图基础参数数据
 * @author lloyd
 * @version 1.0
 * @since 2021/1/29 下午9:32
 */
@Data
public class DiagramCardBaseParam {

    String id;

    String creatTime;

    String prodDate;

    @TableField("wellname")
    String wellName;
    Double[][] sgtFormatted;

    /*
        功图内容，数据库内容 ，位移，载荷整百倍隔开
         */
    @TableField("sgt")
    String sgtStr;
    double s_max;
    double s_min;
    double l_max;
    double l_min;
    //载荷中线值
    double l_mid;
    //功图第一拐点载荷
    double l_fistdownturnpoint;
    //计算出来的冲程
    double s;
    //读过来的冲程 一手源数据
    double s_pre;
    //冲次
    double n;
    // 载荷差值
    double l;
    double s_effect;
    double area;
    //上行载荷均值
    double upload;
    //下行载荷均值
    double download;
    //0: is legal ;1: is illegal ;default:-1
    int islegal;
    /*
    不合法的功图应该有原因说明
     */
    String illegalReason;
    String remark;

    /*
    地面功图 点数
     */
    int sgtpointnum;


    //对应[ s_max  ]的在array中的 index
    int s_max_point_location;
    //对应[ s_min  ]的在array中的 index
    int s_min_point_location;
    //对应[ l_max  ]的在array中的 index
    int l_max_point_location;
    //对应[  l_min ]的在array中的 index
    int l_min_point_location;
}
