package com.gct.aoid.feignclient;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * class name: BaseDataClient
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/25 下午6:02
 */
@FeignClient(value = "centralbase",fallback = BaseDataHystrix.class,url = "192.168.1.6:9002")
public interface BaseDataClient {
    @RequestMapping(value = "/getLatestA2DailyData/{WellID}",method = RequestMethod.GET)
    String getLatestA2DailyData(@PathVariable("WellID") String wellID) ;

    @RequestMapping(value = "/WellSeriesInfo/WellSeriesInfo",method = RequestMethod.GET)
    String getWellSeriesInfo();

    @RequestMapping(value = "/cbPcProWellboreStatusDaily/getA2DataForCalProduction/{WellName}/{dateTime}",method = RequestMethod.GET)
    String getA2DataForCalProduction(@PathVariable("WellName") String wellName,@PathVariable("dateTime") String dateTime);
    @RequestMapping(value = "/cbPcProWellboreVolDaily/getA2DataForCalVolDaily/{WellName}/{dateTime}",method = RequestMethod.GET)
    String getA2DataForCalVolDaily(@PathVariable("WellName") String wellName,@PathVariable("dateTime") String dateTime);

    @RequestMapping(value = "/WellSource/jh",method = RequestMethod.GET)
    String getWellListByOrgID(@RequestParam("orgid") String org);
}
