package com.gct.aoid.job;

import org.springframework.boot.context.properties.ConfigurationProperties;

/**
 * class name: CalLiqDailyJobTriggerConfigProperties
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/21 上午10:35
 */
@ConfigurationProperties(prefix = "spring.quartz.triggers")
public class TriggerConfigProperties {
    private CalTaskTrigger jt1 = new CalTaskTrigger();

    public CalTaskTrigger getJt1() {
        return jt1;
    }

    public void setJt1(CalTaskTrigger jt1) {
        this.jt1 = jt1;
    }

    public static class CalTaskTrigger {
        private int IntervalInSeconds = 1;
        private String JobName = "DEFAULT";
        private String JobGroup = "DEFAULT_GROUP";
        private long DelayMilliseconds = 0;
        private boolean IsRepeatable = false;

        public int getIntervalInSeconds() {
            return IntervalInSeconds;
        }

        public void setIntervalInSeconds(int intervalInSeconds) {
            IntervalInSeconds = intervalInSeconds;
        }

        public String getJobName() {
            return JobName;
        }

        public void setJobName(String jobName) {
            JobName = jobName;
        }

        public String getJobGroup() {
            return JobGroup;
        }

        public void setJobGroup(String jobGroup) {
            JobGroup = jobGroup;
        }

        public long getDelayMilliseconds() {
            return DelayMilliseconds;
        }

        public void setDelayMilliseconds(long delayMilliseconds) {
            DelayMilliseconds = delayMilliseconds;
        }

        public boolean getIsRepeatable() {
            return IsRepeatable;
        }

        public void setIsRepeatable(boolean repeatable) {
            IsRepeatable = repeatable;
        }
    }
}
