package com.gct.aoid.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.aoid.entity.AoidCalprotaskqueue;
import com.gct.aoid.mapper.AoidCalprotaskqueueMapper;
import com.gct.aoid.service.AoidCalprotaskqueueService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gct.common.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author Lloyd
 * @since 2021-02-01
 */
@Service
public class AoidCalprotaskqueueServiceImpl extends ServiceImpl<AoidCalprotaskqueueMapper, AoidCalprotaskqueue> implements AoidCalprotaskqueueService {

    @Autowired
    AoidCalprotaskqueueMapper aoidCalprotaskqueueMapper;

    @Override
    public Result getOneByID(String id) {

        QueryWrapper<AoidCalprotaskqueue> wrapper = new QueryWrapper<>();
        wrapper.eq("id", id);
        AoidCalprotaskqueue a = aoidCalprotaskqueueMapper.selectOne(wrapper);
        return Result.ok(a);
    }

    @Transactional(rollbackFor = RuntimeException.class)
    @Override
    public List<AoidCalprotaskqueue> getTaskList(int num) throws RuntimeException {
        List<AoidCalprotaskqueue> rs = aoidCalprotaskqueueMapper.getTaskRecords(AoidCalprotaskqueue.TaskStatus.ADDED.getCode(), num);
        List<String> rList = new ArrayList<>();
        for (AoidCalprotaskqueue topTenRecord : rs)
            rList.add(topTenRecord.getId());
        boolean sus = aoidCalprotaskqueueMapper.updateStatusByIDList(AoidCalprotaskqueue.TaskStatus.LOCKED.getCode(), rList);
        if (sus)
            return rs;
        else
            throw new RuntimeException("Not available task list");

    }

    @Transactional(rollbackFor = RuntimeException.class)
    public boolean deleteCompletedTask(List<AoidCalprotaskqueue> ts) throws RuntimeException {
        if(ts==null) return true;
        List<String> rList = new ArrayList<>();
        for (AoidCalprotaskqueue a : ts)
            rList.add(a.getId());
        int sus = aoidCalprotaskqueueMapper.deleteBatchIds(rList);
        if (sus == ts.size())
            return true;
        if (ts.size() == 0) return true;

        throw new RuntimeException("delete exited task list failed");
    }
}
