package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.aoid.algorithm.CalDiagramProduction;
import com.gct.aoid.algorithm.CalPumpCard;
import com.gct.aoid.entity.*;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.service.AoidCalprotaskqueueService;
import com.gct.aoid.service.AoidGkModelService;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.aoid.service.AoidSinglewellConfigService;
import com.gct.common.core.result.Result;
import com.gct.common.util.SGTUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Objects;

/**
 * class name: CalDiagramProductionService
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/29 下午9:47
 */
@Component
public class CalDiagramProductionService {

    @Autowired
    private AoidCalprotaskqueueService aoidCalprotaskqueueService;
    @Autowired
    private BaseDataClient baseDataClient;
    @Autowired
    private DiagnoseClient diagnoseClient;
    @Autowired
    private AoidGkModelService aoidGkModelService;
    @Autowired
    private AoidSinglewellConfigService aoidSinglewellConfigService;
    @Autowired
    private CalPumpCard calPumpCard;
    @Autowired
    private CalDiagramProduction calDiagramProduction;
    @Autowired
    private AoidSinglegtYieldService aoidSinglegtYieldService;

    public int sus = 0;

    public void cal(String message) throws InstantiationException, IllegalAccessException {
        //if (message !=null ) return;
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        AoidCalprotaskqueue aoidCalprotaskqueue = JSONObject.parseObject(message, AoidCalprotaskqueue.class);
        String dcbpStr = null;
        DiagramCardBaseParam dcbp;
        SingleDiagramDiagnoseResult sddr;
        ProDataForCalProduction a2data;
        ProDataForCalProduction a2dataVol;
        try {
//            System.out.println("aoidCalprotaskqueue .getSgtbaseparamId= " + aoidCalprotaskqueue.getSgtbaseparamId());
            dcbpStr = diagnoseClient.getDiagramCardBaseParamByID(aoidCalprotaskqueue.getSgtbaseparamId());
//            System.out.println("dcbp json:" + JSONObject.parseObject(dcbpStr, Result.class).toString());
            dcbp = (DiagramCardBaseParam) JSONObject.parseObject(dcbpStr, Result.class).toFiguredOutObject(DiagramCardBaseParam.class);
            dcbp.setSgtFormatted(SGTUtil.encodeToDoubleArray(dcbp.getSgtStr()));
            String sddrStr = diagnoseClient.getSingleDiagramDiagnoseResultByID(aoidCalprotaskqueue.getDiagnoseresultId());
            sddr = (SingleDiagramDiagnoseResult) JSONObject.parseObject(sddrStr, Result.class).toFiguredOutObject(SingleDiagramDiagnoseResult.class);
//            System.out.println("dcbp.getReceiveTime() = " + dcbp.getProdDate());
//            System.out.println("dcbp.getWellName() = " + dcbp.getWellName());
            String a2dataStr = baseDataClient.getA2DataForCalProduction(dcbp.getWellName(), dcbp.getProdDate().substring(0, 10));
            a2data = (ProDataForCalProduction) JSONObject.parseObject(a2dataStr, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
          //  if (a2data != null) System.out.println("a2data = " + a2data);
            String a2dataStrVol = baseDataClient.getA2DataForCalVolDaily(dcbp.getWellName(), dcbp.getProdDate().substring(0, 10));
            a2dataVol = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrVol, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
           // if (a2dataVol != null) System.out.println("a2dataStrVol = " + a2dataVol);
        } catch (Exception e) {
            throw new RuntimeException("[aoid->CalDiagramProductionService->cal:] fegin error ");
        }
        AoidGkModel model = aoidGkModelService.getGKModelByResultType(sddr.getResult1());
        AoidSinglewellConfig effectStrockModel = aoidSinglewellConfigService.getConfigOneObjByID(1);
        Double[][] bgt = calPumpCard.cal_bgt(dcbp, sddr);
        CalDiagramProduction.CalProductionResult production = new CalDiagramProduction.CalProductionResult();

        boolean checked = checkInputDataBeforeCalDiagramProduction(production, a2data, a2dataVol, bgt, dcbp, model, effectStrockModel);
        AoidSinglegtYield aoidSinglegtYield = new AoidSinglegtYield();
        aoidSinglegtYield.setRemark(production.remark);
        if (checked) {
            production = calDiagramProduction.calProduction(
                    dcbp.getSgtFormatted(),
                    bgt,
                    dcbp.getS(),
                    dcbp.getN(),
                    sddr.getResult1(),
                    a2data.getBj(),
                    a2data.getBs(),
                    a2dataVol.getHsl() / 100,
                    a2dataVol.getSmd(),
                    a2dataVol.getYmd(),
                    a2dataVol.getQyb(),
                    a2data.getDym(),
                    model.getGkxs(),
                    effectStrockModel
            );
            /*if (production != null)
                System.out.println("production-remark = " + production.remark);*/
            sus++;
          /*  System.out.println("sus = " + sus);*/
        }
        aoidCalprotaskqueue.setStatus(AoidCalprotaskqueue.TaskStatus.COMPLETED.getCode());
//        System.out.println("JSONObject.toJSONString(production) = " + JSONObject.toJSONString(production));


        if (dcbp != null) {
            aoidSinglegtYield.setWellId(dcbp.getWellName());
            aoidSinglegtYield.setWellCommonName(dcbp.getWellName());
            if (dcbp.getProdDate() != null)
                try {
                    aoidSinglegtYield.setProdDate(LocalDateTime.parse(dcbp.getProdDate(), df));
                } catch (Exception e) {
                    System.out.println("dcbp.getProdDate() ERROR= " + dcbp.getProdDate());
                }
            aoidSinglegtYield.setStroke(dcbp.getS());
            aoidSinglegtYield.setFrequence(dcbp.getN());
            aoidSinglegtYield.setSxzh(dcbp.getL_max());
            aoidSinglegtYield.setXxzh(dcbp.getL_min());
            aoidSinglegtYield.setSgt(dcbp.getSgtStr());
        }
        if (a2data != null) {
            aoidSinglegtYield.setBj(a2data.getBj());
            aoidSinglegtYield.setBs(a2data.getBs());
            aoidSinglegtYield.setCmd(a2data.getBs());
            aoidSinglegtYield.setYzzj(a2data.getBj());
            aoidSinglegtYield.setHsl(a2dataVol.getHsl());
            aoidSinglegtYield.setHy(a2data.getBack_pres());
            aoidSinglegtYield.setYy(a2data.getTubing_pres());
            aoidSinglegtYield.setTy(a2data.getCasing_pres());
            aoidSinglegtYield.setDym(a2data.getDym());
        }
        if (a2dataVol != null) {

            aoidSinglegtYield.setSmd(a2dataVol.getSmd());
            aoidSinglegtYield.setYmd(a2dataVol.getYmd());
            aoidSinglegtYield.setQyb(a2dataVol.getQyb());
        }
        //sddr must be not null
        aoidSinglegtYield.setEczdjg(sddr.getResult2());
        aoidSinglegtYield.setZdjg(sddr.getResult1());

        if (bgt != null && bgt.length > 0) {
//            System.out.println("SGTUtil.encodeToString(bgt) = " + SGTUtil.encodeToString(bgt));
            aoidSinglegtYield.setBgt(SGTUtil.encodeToString(bgt));
        }
        if (production != null) {
            aoidSinglegtYield.setLiqProdDaily(production.rcyl);
            aoidSinglegtYield.setOilProdDaily(production.rcyl1);
            aoidSinglegtYield.setGasProdDaily(production.rcql);
            aoidSinglegtYield.setBx(production.bx);
            //aoidSinglegtYield.setFlag();
            //aoidSinglegtYield.setBdxs();
            aoidSinglegtYield.setLlpl(production.llpl);
            aoidSinglegtYield.setZcc(production.zcc);
            aoidSinglegtYield.setSjcc(production.sjcc);
            aoidSinglegtYield.setYxcc(production.yxcc);
            aoidSinglegtYield.setCcss(production.ccss);
            aoidSinglegtYield.setLsss(production.lsss);
            aoidSinglegtYield.setGyss(production.gyss);
            aoidSinglegtYield.setWaterProdDaily(production.rcsl);
            aoidSinglegtYield.setStrokeRatio(production.l_StrokeRatio);
        }
        aoidSinglegtYield.setScsj(24d);
        /*aoidSinglegtYield.setDjdy();
            aoidSinglegtYield.setHjwd();
            aoidSinglegtYield.setYbdl();
            aoidSinglegtYield.setXhqd();
            aoidSinglegtYield.setSbh();*/

        System.out.println("aoidSinglegtYield = " + aoidSinglegtYield);
        aoidSinglegtYieldService.saveOrUpdate(aoidSinglegtYield,
                new LambdaQueryWrapper<AoidSinglegtYield>()
                        .eq(AoidSinglegtYield::getWellId, aoidSinglegtYield.getWellId())
                        .eq(AoidSinglegtYield::getProdDate, aoidSinglegtYield.getProdDate())
        );

    }


    //public final static String[] name = {"N", "S", "BJ", "BS", "DYM", "HSL", "SMD", "QYB", "YMD"};
//    public static int[] count = {0, 0, 0, 0, 0, 0, 0, 0, 0};

    private boolean checkInputDataBeforeCalDiagramProduction(CalDiagramProduction.CalProductionResult production, ProDataForCalProduction a2data, ProDataForCalProduction a2dataVol, Double[][] bgt, DiagramCardBaseParam dcbp, AoidGkModel model, AoidSinglewellConfig effectStrockModel) {
        production.remark = "found unexpected data";
        if (bgt == null || bgt.length == 0) return false;

        if (Objects.isNull(dcbp)) return false;
        if (Objects.isNull(dcbp.getN())) {
//            count[0]++;
            return false;
        }
        if (Objects.isNull(dcbp.getS())) {
//            count[1]++;
            return false;

        }

        if (Objects.isNull(a2data)) return false;
        if (Objects.isNull(a2data.getBj())) {
//            count[2]++;
            return false;
        }
        if (Objects.isNull(a2data.getBs())) {
//            count[3]++;
            return false;
        }
        if (Objects.isNull(a2data.getDym())) {
//            count[4]++;
            a2data.setDym(0.0);
            // return false;
        }

        if (Objects.isNull(a2dataVol)) return false;
        if (Objects.isNull(a2dataVol.getHsl())) {
//            count[5]++;
            return false;
        }
        if (Objects.isNull(a2dataVol.getSmd())) {
//            count[6]++;
            a2dataVol.setSmd(1.0);
        }
        if (Objects.isNull(a2dataVol.getQyb())) {
//            count[7]++;
            return false;
        }
        if (Objects.isNull(a2dataVol.getYmd())) {
//            count[8]++;
            a2dataVol.setYmd(0.84);
        }

        if (Objects.isNull(model) || Objects.isNull(model.getGkxs())) return false;

        if (Objects.isNull(effectStrockModel)) return false;
        production.remark = "checked legal";
        return true;
    }
}
