package com.gct.aoid.service.impl;

import com.gct.aoid.service.TaskConsumerService;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.spring.annotation.ConsumeMode;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service
@RocketMQMessageListener(
        nameServer = "${rocketmq.nameserver}",
        topic = "aoid-topic",
        consumerGroup = "aoid",
        consumeMode = ConsumeMode.ORDERLY //保证同一队列顺序消费
)
public class TaskConsumerServiceImpl implements TaskConsumerService {

   @Autowired
    CalDiagramProductionService calDiagramProductionService;

    @Override
    public void onMessage(String message) {
        try {
            calDiagramProductionService.cal(message);
        } catch (InstantiationException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }
    }
}
