package com.gct.aoid.RocketMQ;


import com.gct.aoid.ProductionCalApplication;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.consumer.DefaultMQPushConsumer;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyContext;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyStatus;
import org.apache.rocketmq.client.consumer.listener.MessageListenerConcurrently;
import org.apache.rocketmq.client.exception.MQClientException;
import org.apache.rocketmq.common.message.MessageExt;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class ProducerTest {

        @Resource
        private RocketMQTemplate rocketMQTemplate;

        @Test
        public void Test(){
                /**
                 * hashKey: 为了保证报到同一个队列中，将消息发送到ly主题上
                 */
                Map<String,Object> map = new HashMap<>();
                map.put("sgtbaseparamId","ff9b1cf1-897d-454c-ac81-720498d38619");
                map.put("diagnoseresultId","0e860423-49f6-43a1-9b17-ce26460a77ff");
                map.put("id","8");
                //map.put("createtime","2021-01-25 10:00:00");
                //map.put("status","0");
                //map.put("sgtFormatted","0,4176,0,4208,1,4256,3,4304,6,4416,9,4496,12,4576,17,4768,21,4864,25,4912,32,4864,38,4784,43,4704,52,4560,59,4496,66,4480,73,4496,84,4608,92,4688,100,4736,112,4816,121,4816,129,4800,143,4704,152,4640,161,4592,175,4560,185,4560,194,4576,204,4592,218,4640,227,4656,237,4656,251,4640,260,4624,269,4592,283,4512,292,4480,300,4464,313,4432,321,4432,329,4448,337,4448,348,4432,355,4400,362,4368,371,4304,377,4256,383,4208,390,4128,395,4112,399,4096,405,4064,408,4064,411,4047,414,4064,416,4064,418,4047,419,4047,419,4032,419,4015,419,3968,417,3904,416,3856,414,3792,410,3600,407,3536,403,3504,399,3520,393,3584,388,3647,383,3711,374,3824,368,3808,362,3776,352,3679,345,3615,337,3568,326,3504,317,3520,309,3536,301,3584,288,3647,279,3664,270,3664,256,3647,247,3600,237,3568,223,3520,213,3504,204,3504,190,3536,180,3568,171,3600,161,3615,148,3647,139,3647,130,3632,117,3615,108,3615,100,3615,88,3632,80,3664,73,3696,63,3760,56,3792,50,3808,44,3840,35,3856,30,3856,25,3872,19,3904,15,3920,12,3952,7,4015,5,4047,3,4064,1,4096,0,4112,0,4112");
                rocketMQTemplate.sendOneWayOrderly("aoid-topic",map,(String)map.get("diagnoseresultId"));
                System.out.println(" send map"+map);
                System.out.println("send success ");

        }

        public static void main(String[] args) throws InterruptedException, MQClientException {

                // 实例化消费者
                DefaultMQPushConsumer consumer = new DefaultMQPushConsumer("aoid");

                // 设置NameServer的地址
                consumer.setNamesrvAddr("101.200.219.190:9876");

                // 订阅一个或者多个Topic，以及Tag来过滤需要消费的消息
                consumer.subscribe("aoid-topic", "*");
                // 注册回调实现类来处理从broker拉取回来的消息
                consumer.registerMessageListener(new MessageListenerConcurrently() {
                        @Override
                        public ConsumeConcurrentlyStatus consumeMessage(List<MessageExt> msgs, ConsumeConcurrentlyContext context) {
                                System.out.println(msgs);
                                // 标记该消息已经被成功消费
                                return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
                        }
                });
                // 启动消费者实例
                consumer.start();
        }





}
