package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.aoid.ProductionCalApplication;
import com.gct.aoid.entity.AoidCalprotaskqueue;
import com.gct.aoid.feignclient.DiagnoseClient;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.time.LocalDateTime;
import java.util.UUID;

@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class CalDiagramProductionServiceTest {

    @Autowired
    CalDiagramProductionService calDiagramProductionService;

    @Autowired
    DiagnoseClient diagnoseClient;
    @Test
    public void test() {

        JSONObject allResult = JSONObject.parseObject( diagnoseClient.getAllResult());

        JSONArray data = allResult.getJSONArray("data");
        System.out.println("data.size() = " + data.size());
        for (int i = 0; i < data.size(); i++) {
            AoidCalprotaskqueue msg = new AoidCalprotaskqueue();
            msg.setStatus(AoidCalprotaskqueue.TaskStatus.ADDED.getCode());
//            System.out.println("data.getJSONObject(i).toJSONString() = " + data.getJSONObject(i).toJSONString());
            msg.setDiagnoseresultId(data.getJSONObject(i).getString("resultId"));
            msg.setSgtbaseparamId(data.getJSONObject(i).getString("gtbaseparamId"));
            msg.setCreatetime(LocalDateTime.now());
            msg.setId(UUID.randomUUID().toString());
            try {
                calDiagramProductionService.cal(JSONObject.toJSONString(msg));
            } catch (InstantiationException e) {
               // System.out.println("e1.getMessage() = " + e.getMessage());
            } catch (IllegalAccessException e) {
                //System.out.println("e2 = " + e.getMessage());
            }
            //System.out.println("msg run completed=>>>>>>" + msg.toString());
        }

        System.out.println("success:---->"+calDiagramProductionService.sus);
//        for (int i = 0; i < CalDiagramProductionService.count.length; i++) {
//            System.out.println(CalDiagramProductionService.name[i] +":"+ CalDiagramProductionService.count[i]);
//        }

    }

}